classification
Title: selector_events.BaseSelectorEventLoop.sock_connect should preserve socket type
Type: behavior Stage:
Components: asyncio Versions: Python 3.7, Python 3.6, Python 3.5
process
Status: open Resolution:
Dependencies: Superseder:
Assigned To: Nosy List: apatrushev, asvetlov, gus.goulart, sebastien.bourdeauducq, taleinat, yselivanov
Priority: normal Keywords: patch

Created on 2018-05-29 09:43 by sebastien.bourdeauducq, last changed 2018-11-07 00:33 by gus.goulart.

Files
File name Uploaded Description Edit
test.py apatrushev, 2018-07-26 14:11
issue33678.patch gus.goulart, 2018-11-07 00:33
Messages (5)
msg318001 - (view) Author: Sebastien Bourdeauducq (sebastien.bourdeauducq) * Date: 2018-05-29 09:43
The current behavior causes an exception to be raised when trying to create a datagram socket and _ipaddr_info returns None (since asyncio then calls loop.getaddrinfo with SOCK_STREAM and IPPROTO_UDP).

Preserving socket type is made difficult by https://bugs.python.org/issue21327; the proposed patch includes a dirty workaround. I do not know yet if it works on Windows.

--- selector_events.py  2018-05-11 10:01:42.011164837 +0800
+++ selector_events.py.new      2018-05-29 17:41:03.103155480 +0800
@@ -439,8 +439,9 @@
             raise ValueError("the socket must be non-blocking")
 
         if not hasattr(socket, 'AF_UNIX') or sock.family != socket.AF_UNIX:
+            socktype = sock.type & 0xf  # WA https://bugs.python.org/issue21327
             resolved = base_events._ensure_resolved(
-                address, family=sock.family, proto=sock.proto, loop=self)
+                address, family=sock.family, type=socktype, proto=sock.proto, loop=self)
             if not resolved.done():
                 yield from resolved
             _, _, _, _, address = resolved.result()[0]
msg318002 - (view) Author: Sebastien Bourdeauducq (sebastien.bourdeauducq) * Date: 2018-05-29 09:50
Windows looks fine.
msg318047 - (view) Author: Yury Selivanov (yselivanov) * (Python committer) Date: 2018-05-29 15:45
Can you write a unittest that exposes the bug?
msg322429 - (view) Author: Anton Patrushev (apatrushev) Date: 2018-07-26 14:11
I created small script showing the error.
msg329399 - (view) Author: Gus Goulart (gus.goulart) * Date: 2018-11-07 00:33
This error seems to come from base_events.py, lines 142-145, and since it's an OS specific limitation, I can't see Sebastien's suggestion as a feasible solution.
Maybe we could come up with something along the lines of the following patch. What do you think about it?

diff --git a/Lib/asyncio/base_events.py b/Lib/asyncio/base_events.py
index 3726c556d4..15ee4d9d1b 100644
--- a/Lib/asyncio/base_events.py
+++ b/Lib/asyncio/base_events.py
@@ -142,6 +142,9 @@ def _ipaddr_info(host, port, family, type, proto):
     if '%' in host:
         # Linux's inet_pton doesn't accept an IPv6 zone index after host,
         # like '::1%lo0'.
+        if sys.platform.startswith('linux'):
+            return OSError("Linux's inet_pton doesn't accept an IPv6 "
+                           "zone index after host")
         return None
 
     for af in afs:
diff --git a/Lib/test/test_asyncio/test_base_events.py b/Lib/test/test_asyncio/test_base_events.py
index 6d544d1eda..1b944ff89e 100644
--- a/Lib/test/test_asyncio/test_base_events.py
+++ b/Lib/test/test_asyncio/test_base_events.py
@@ -109,6 +109,9 @@ class BaseEventTests(test_utils.TestCase):
         self.assertIsNone(
             base_events._ipaddr_info('::3', 1, INET, STREAM, TCP))
 
+    @unittest.skipIf(sys.platform.startswith('linux'),
+        "Linux's inet_pton doesn't accept an IPv6 zone index after host")
+    def test_for(self):
         # IPv6 address with zone index.
         self.assertIsNone(
             base_events._ipaddr_info('::3%lo0', 1, INET6, STREAM, TCP))
History
Date User Action Args
2018-11-07 00:33:30gus.goulartsetfiles: + issue33678.patch

nosy: + taleinat, gus.goulart
messages: + msg329399

keywords: + patch
2018-07-26 14:11:57apatrushevsetfiles: + test.py
versions: + Python 3.7
nosy: + apatrushev

messages: + msg322429
2018-05-29 15:45:28yselivanovsetmessages: + msg318047
2018-05-29 09:50:16sebastien.bourdeauducqsetmessages: + msg318002
2018-05-29 09:43:27sebastien.bourdeauducqcreate